// BindTexture.cpp: implementation of the CBindTexture class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Kurushi.h"
#include "BindTexture.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTextureNum::CTextureNum (GLuint n)
{
	m_Texture_num = n;
	m_nb_created = 1;
}

CBindTexture::CBindTexture()
{

}

CBindTexture::~CBindTexture()
{
	POSITION pos;
	CTextureNum *num;
	CString key;

	pos = m_Texture_map.GetStartPosition();
	while (pos)
	{
		m_Texture_map.GetNextAssoc(pos, key, num);
		glDeleteTextures(1, &num->m_Texture_num);
		delete num;
		m_Texture_map.RemoveKey(key);
	}

}

GLuint CBindTexture::LoadTexture(CString filename, bool transparent, char alpha)
{
	GLuint m_Texture_num;
	CTextureNum *num;

	if (m_Texture_map.Lookup(filename, num))
	{
		#ifdef _DEBUG
		afxDump << "Texture " << filename << " deja chargee. ";
		#endif		
		num->m_nb_created++;
		return num->m_Texture_num;
	}

	#ifdef _DEBUG
	afxDump << "Nouvelle texture " << filename << ". ";
	#endif		
	CTexture Texture;
	Texture.ReadFile(filename);
	Texture.BGRtoRGB();
	if(Texture.GetData())
	{
		glGenTextures(1, &m_Texture_num);
		glBindTexture(GL_TEXTURE_2D, m_Texture_num);
		if (transparent)
		{
			Texture.AddAlphaLayer(alpha);
			gluBuild2DMipmaps(GL_TEXTURE_2D, 4, Texture.GetWidth(), Texture.GetHeight(), GL_RGBA, GL_UNSIGNED_BYTE, Texture.GetData());
		}
		else
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, Texture.GetWidth(), Texture.GetHeight(), GL_RGB, GL_UNSIGNED_BYTE, Texture.GetData());
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	}
	num = new CTextureNum(m_Texture_num);
	m_Texture_map.SetAt(filename, num);
	return m_Texture_num;
}

void CBindTexture::FreeTexture(GLuint n)
{
	POSITION pos;
	CTextureNum *num;
	CString key;

	pos = m_Texture_map.GetStartPosition();
	while (pos)
	{
		m_Texture_map.GetNextAssoc(pos, key, num);
		if (num->m_Texture_num == n)
		{
			num->m_nb_created--;
			if (num->m_nb_created == 0)
			{
				glDeleteTextures(1, &num->m_Texture_num);
				delete num;
				m_Texture_map.RemoveKey(key);
			}
		}
	}
}
