// GLFont.cpp: implementation of the CGLFont class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Kurushi.h"
#include "GLFont.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGLFont::CGLFont(HDC hdc, char  *typeface, int   height, int weight, DWORD italic)
{
	HFONT	font, old;			/* Windows font ID */

	if ((base = glGenLists(96)) == 0)
		return;

	font = CreateFont(height, 0, 0, 0, weight, italic, FALSE, FALSE, ANSI_CHARSET, OUT_TT_PRECIS,  CLIP_DEFAULT_PRECIS, DRAFT_QUALITY,  DEFAULT_PITCH, typeface);
	old = (HFONT)SelectObject(hdc, font);
	wglUseFontBitmaps(hdc, 32, 96, base);
	SelectObject(hdc, old);
}

CGLFont::~CGLFont()
{
	if (base == 0)
		return;

	glDeleteLists(base, 96);
}

void CGLFont::FontPuts(char *s, GLfloat *pos)
{
	if (!base || !s)
		return;

	glRasterPos3fv(pos);
	glPushAttrib(GL_LIST_BIT);
		glListBase(base - 32);
		glCallLists(strlen(s), GL_UNSIGNED_BYTE, s);
	glPopAttrib();
}