// KurushiView.cpp : implementation of the CKurushiView class
//

#include "stdafx.h"
#include "Kurushi.h"

#include "KurushiDoc.h"
#include "KurushiView.h"

#include "math.h"
#include "Light.h"
#include "FpsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ANGLE_STEP 0.050f
#define NB_DALLEX	5
#define NB_DALLEY	1
#define NB_DALLEZ	25

#define PI 3.14159265f

CFpsDlg *fps = NULL;

/////////////////////////////////////////////////////////////////////////////
// CKurushiView

IMPLEMENT_DYNCREATE(CKurushiView, CView)

BEGIN_MESSAGE_MAP(CKurushiView, CView)
	//{{AFX_MSG_MAP(CKurushiView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_SETCURSOR()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKurushiView construction/destruction

CKurushiView::CKurushiView()
{
	// TODO: add construction code here
	m_hGLContext = NULL;
	m_GLPixelIndex = 0;
	m_x = 4;
	m_y = 3.5;
	m_z = 5;
	m_cx = 3;
	m_cy = 1;
	m_cz = -3.5;

	m_upx = m_upz = 0;	m_upy = 1;
	m_alpha_layer = 175;

	m_light = NULL;
	m_sol = NULL;
	m_rc = NULL;
	m_j = NULL;
	f = NULL;

	fps = new CFpsDlg;
}

CKurushiView::~CKurushiView()
{
	if (fps)
		delete fps;
	if (m_light)
		delete m_light;
	if (m_rc)
		delete m_rc;
	if (m_sol)
		delete m_sol;
	if (m_j)
		delete m_j;
	if (f)
		delete f;
}

BOOL CKurushiView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);
	cs.lpszClass = AfxRegisterWndClass(CS_OWNDC);

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CKurushiView drawing

void CKurushiView::OnDraw(CDC* pDC)
{
	CKurushiDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CKurushiView diagnostics

#ifdef _DEBUG
void CKurushiView::AssertValid() const
{
	CView::AssertValid();
}

void CKurushiView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CKurushiDoc* CKurushiView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CKurushiDoc)));
	return (CKurushiDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CKurushiView message handlers

BOOL CKurushiView::SetWindowPixelFormat(HDC hDC)
{
	PIXELFORMATDESCRIPTOR pixelDesc;

	pixelDesc.nSize		= sizeof(PIXELFORMATDESCRIPTOR);
	pixelDesc.nVersion	= 1;

	pixelDesc.dwFlags	=	PFD_DRAW_TO_WINDOW | 
							PFD_SUPPORT_OPENGL | 
							PFD_DOUBLEBUFFER |
							PFD_STEREO_DONTCARE;

	pixelDesc.iPixelType		= PFD_TYPE_RGBA;
	pixelDesc.cColorBits		= 32;
	pixelDesc.cRedBits			= 8;
	pixelDesc.cRedShift			= 16;
	pixelDesc.cGreenBits		= 8;
	pixelDesc.cGreenShift		= 8;
	pixelDesc.cBlueBits			= 8;
	pixelDesc.cBlueShift		= 0;
	pixelDesc.cAlphaBits		= 8;
	pixelDesc.cAlphaShift		= 24;
	pixelDesc.cAccumBits		= 64;	
	pixelDesc.cAccumRedBits		= 16;
	pixelDesc.cAccumGreenBits	= 16;
	pixelDesc.cAccumBlueBits	= 16;
	pixelDesc.cAccumAlphaBits	= 0;
	pixelDesc.cDepthBits		= 32;
	pixelDesc.cStencilBits		= 8;
	pixelDesc.cAuxBuffers		= 0;
	pixelDesc.iLayerType		= PFD_MAIN_PLANE;
	pixelDesc.bReserved			= 0;
	pixelDesc.dwLayerMask		= 0;
	pixelDesc.dwVisibleMask		= 0;
	pixelDesc.dwDamageMask		= 0;

	m_GLPixelIndex = ChoosePixelFormat(hDC, &pixelDesc);
	if (m_GLPixelIndex==0)
	{
		m_GLPixelIndex = 1;	// Let's choose a default index.
		if (DescribePixelFormat( hDC, m_GLPixelIndex, sizeof(PIXELFORMATDESCRIPTOR), &pixelDesc) == 0)
		{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("DescribePixelFormat returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return FALSE;
		}
	}

	if (SetPixelFormat(	hDC, m_GLPixelIndex, &pixelDesc) ==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("SetPixelFormat returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}
	return TRUE;
}

int CKurushiView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	((CKurushiApp *)AfxGetApp())->m_pView = (void *)this;

	HWND hWnd = GetSafeHwnd();
	HDC hDC = ::GetDC(hWnd);

	if (SetWindowPixelFormat(hDC)==FALSE)
		return 0;

	if (CreateViewGLContext(hDC)==FALSE)
		return 0;

	if (fps->GetSafeHwnd() == 0)	
		fps->Creer();

	return 0;
}

BOOL CKurushiView::CreateViewGLContext(HDC hDC)
{
	m_hGLContext = wglCreateContext(hDC);
	if (m_hGLContext == NULL)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	if (wglMakeCurrent(hDC, m_hGLContext)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;
}

void CKurushiView::OnDestroy() 
{
	if(wglGetCurrentContext()!=NULL) 
	{
		// make the rendering context not current
		wglMakeCurrent(NULL, NULL) ;
	}
	
	if (m_hGLContext!=NULL)
	{
		wglDeleteContext(m_hGLContext);
		m_hGLContext = NULL;
	}

	// Now the associated DC can be released.
	CView::OnDestroy();
	
	// TODO: Add your message handler code here	
}

void CKurushiView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	RenderScene ();
	SwapBuffers(dc.m_ps.hdc);	
	// Do not call CView::OnPaint() for painting messages
}

BOOL CKurushiView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default
	SetCursor (NULL);
	
	return CView::OnSetCursor(pWnd, nHitTest, message);
}

void CKurushiView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	switch (nChar)
	{
	case VK_UP :
		m_j->m_h = true;
		break;
	case VK_DOWN:
		m_j->m_b = true;
		break;
	case VK_LEFT :
		m_j->m_g = true;
		break;
	case VK_RIGHT:
		m_j->m_d = true;
		break;
	case VK_END:
		m_j->m_a1 = true;
		break;
	case VK_DELETE:
		m_j->m_a2 = true;
		break;
	case VK_F1:
		m_j->m_ClipSol = !m_j->m_ClipSol;
		break;
	case VK_F2:
		m_j->m_ClipRC = !m_j->m_ClipRC;
		break;
	}
	
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CKurushiView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	switch (nChar)
	{
	case VK_UP :
		m_j->m_h = false;
		break;
	case VK_DOWN:
		m_j->m_b = false;
		break;
	case VK_LEFT :
		m_j->m_g = false;
		break;
	case VK_RIGHT:
		m_j->m_d = false;
		break;
	case VK_END:
		m_j->m_a1 = false;
		break;
	case VK_DELETE:
		m_j->m_a2 = false;
		break;
	}	
	CView::OnKeyUp(nChar, nRepCnt, nFlags);
}

void CKurushiView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	
	GLsizei width, height;
	GLdouble aspect;

	width = cx;
	height = cy;

	if (cy==0)
		aspect = (GLdouble)width;
	else
		aspect = (GLdouble)width/(GLdouble)height;

	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45, aspect, 0.5, 100.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glDrawBuffer(GL_BACK);

	glPolygonMode(GL_FRONT,GL_FILL);
	glPolygonMode(GL_BACK,GL_FILL);
	glShadeModel(GL_SMOOTH);


	if (!m_light)
	{
		GLfloat	ambientProperties[]  = {0.8f, 0.8f, 0.8f, 1.0f};
		GLfloat	diffuseProperties[]  = {0.9f, 0.9f, 0.9f, 1.0f};
		GLfloat	specularProperties[] = {1.0f, 1.0f, 1.0f, 1.0f};
		GLfloat	positionProperties[] = {3.0f, 3.0f, -3.0f, 1.0f};

		m_light = new CLight(positionProperties);
		m_light->SetCarac(ambientProperties, diffuseProperties, specularProperties);
	}

	if (!m_sol)
		m_sol = new CSol(NB_DALLEX, NB_DALLEY, NB_DALLEZ, 1.0f, CString("GFx\\Marbre2.bmp"));
	if (!m_rc)
		m_rc = new CRollingCube(NB_DALLEX, 7, 1.0f, CString("Gfx\\Marbre2.bmp"), 0, 0, -NB_DALLEZ);
	if (!m_j)
		m_j = new CJoueur("cle.obj");
	if (!f)
		f = new CGLFont(::GetDC(GetSafeHwnd()), "arial", 20, 10, 0);

	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, 0);
	glPolygonMode(GL_BACK,GL_FILL);

	glEnable(GL_LIGHTING);

    GLfloat ambient[]  = { 0.2f, 0.2f, 0.2f, 1.0f };
    GLfloat diffuse[]  = { 0.8f, 0.8f, 0.8f, 1.0f };
    GLfloat specular[] = { 0.0f, 0.0f, 0.0f, 1.0f };
    GLfloat shininess  = 10.0;

    glMaterialfv(GL_FRONT, GL_AMBIENT, ambient);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse);
    glMaterialfv(GL_FRONT, GL_SPECULAR, specular);
    glMaterialf(GL_FRONT, GL_SHININESS, shininess);

	// Modulate : texture lighting
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	glEnable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);
//	glEnable(GL_CULL_FACE);
}

void CKurushiView::RenderScene()
{
	static DWORD t = GetTickCount();
	DWORD elapsed_t = GetTickCount() - t;
	t = GetTickCount();

	if (elapsed_t == 0)
		return;

	GLfloat from[3];
	GLfloat at[] = {1.0f,0.5f,-1.0f};
	static CFlare flare(at, 0.3f, 0.7f, 0.7f);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glPushMatrix();
		from[0] = m_j->m_x + float(3*sin(m_j->m_angle*PI/180));
		from[1] = m_j->m_y+1;
		from[2] = m_j->m_z + float(3*cos(m_j->m_angle*PI/180));
		gluLookAt(from[0], from[1], from[2], m_j->m_x, m_j->m_y, m_j->m_z,m_upx,m_upy,m_upz);
		m_light->SetPos(m_j->m_x, m_j->m_y+0.5f, m_j->m_z);

		flare.SetPos(at);
		m_sol->Update(elapsed_t);
		m_sol->Draw();
		m_rc->Update(elapsed_t, m_sol);
		m_rc->Draw();
		m_j->Update(elapsed_t, m_sol, m_rc);
		m_j->Draw();
		flare.Draw(from);
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	GLfloat pos[3] = {10,10,10};
	f->FontPuts("a", pos);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_LIGHTING);

    glFlush();

	if (fps)
	{
		fps->Update(elapsed_t);
	}
}
