// KurushiView.h : interface of the CKurushiView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_KURUSHIVIEW_H__6E37370C_3D1B_11D3_A9DB_525400E10345__INCLUDED_)
#define AFX_KURUSHIVIEW_H__6E37370C_3D1B_11D3_A9DB_525400E10345__INCLUDED_

#include "Texture.h"	// Added by ClassView
#include "Light.h"	// Added by ClassView
#include "Joueur.h"
#include "Sol.h"
#include "RollingCube.h"
#include "Flare.h"
#include "GLFont.h"
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CKurushiView : public CView
{
protected: // create from serialization only
	CKurushiView();
	DECLARE_DYNCREATE(CKurushiView)

// Attributes
public:
	CKurushiDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKurushiView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	CGLFont *f;
	CJoueur * m_j;
	CRollingCube* m_rc;
	CSol* m_sol;
	CLight *m_light;
	unsigned char m_alpha_layer;
	void RenderScene ();
	virtual ~CKurushiView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	float m_x,m_y,m_z,m_cx,m_cy,m_cz,m_upx,m_upy,m_upz;
	CTexture m_Texture;
	HGLRC m_hGLContext;
	BOOL CreateViewGLContext (HDC hDC);
	int m_GLPixelIndex;
	BOOL SetWindowPixelFormat (HDC hDC);
	//{{AFX_MSG(CKurushiView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnBlend();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in KurushiView.cpp
inline CKurushiDoc* CKurushiView::GetDocument()
   { return (CKurushiDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KURUSHIVIEW_H__6E37370C_3D1B_11D3_A9DB_525400E10345__INCLUDED_)
