// Sol.h: interface for the CSol class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOL_H__0A5422A3_5A3C_11D3_A9DB_525400E10345__INCLUDED_)
#define AFX_SOL_H__0A5422A3_5A3C_11D3_A9DB_525400E10345__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CSol;

#include "Cube.h"
#include "RollingCube.h"
#include "Joueur.h"

enum {NORMAL, FALLING, DISABLED};

struct sol_option
{
	int mode;
	int option;
};

class CSol
{
public:
	int v_fall;
	void ReduceZ();
	int z_offs;
	inline int GetSizex() {return m_sizex;};
	inline int GetSizez() {return m_sizez;};
	void Action(CJoueur *j, CRollingCube *r);
	bool Marque(float x, float z, int couleur);
	CSol(int sizex, int sizey, int sizez, float r, CString& texture_filename, float posx = 0, float posy = 0, float posz = 0);
	virtual ~CSol();

	virtual void Update(int t);
	virtual void Draw();
	sol_option **m_option;
	float m_posx, m_posy, m_posz;
	float m_r;
	
protected:
	int m_sizex, m_sizey, m_sizez;
	int m_t;
	CCube * c;
	float m_free_sin;
};

#endif // !defined(AFX_SOL_H__0A5422A3_5A3C_11D3_A9DB_525400E10345__INCLUDED_)
